# A Formal Model of the Document Object Model (Core_SC_DOM)

This git repository contains a local mirror of
the [Archive of Formal Proofs (AFP)](https://www.isa-afp.org).
entry [*A Formal Model of the Document Object Model*.](https://www.isa-afp.org/entries/Core_SC_DOM.shtml)

The official AFP releases are tagged. Additionally, this repository
may contain extensions (i.e., a development version) that may be
submitted at a later point in time.

## How to build

```console
achim@logicalhacking:~$ isabelle build -D Core_SC_DOM
```

## Authors

* [Achim D. Brucker](http://www.brucker.ch/)
* [Michael Herzberg](http://www.dcs.shef.ac.uk/cgi-bin/makeperson?M.Herzberg)

## License

This project is licensed under a 3-clause BSD-style license.

SPDX-License-Identifier: BSD-3-Clause

## Master Repository

The master git repository for this project is hosted by the [Software
Assurance & Security Research Team](https://logicalhacking.com) at
<https://git.logicalhacking.com/afp-mirror/Core_SC_DOM>.

## Publications

* Achim D. Brucker and Michael Herzberg. A Formal Semantics of the Core DOM in 
  Isabelle/HOL. In The 2018 Web Conference Companion (WWW). Pages 741-749, 
  ACM Press, 2018.
  <https://www.brucker.ch/bibliography/abstract/brucker.ea-core-dom-2018>
* Achim D. Brucker and Michael Herzberg. Formalizing (Web) Standards: An 
  Application of Test and Proof. In TAP 2018: Tests And Proofs. Lecture Notes 
  in Computer Science (10889), pages 159-166, Springer-Verlag, 2018.
  <https://www.brucker.ch/bibliography/abstract/brucker.ea-standard-compliance-testing-2018>
